/*
 * (c) 2005 by Simon Gander <simongander@gmx.ch>
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

package guettingen;

/**
 * @author Simon Gander
 */

public class Bahnhof implements Runnable {
	public Bahnhof (Block bk) {
		block = bk;
	}
	
	public void sendeZug (int l) {
		zl = l;
		
		if (lock) return;
		if (block.status != 0) return;
		new Thread(this).start();
	}
	
	public void run() {
		Zug z;
		
		lock = true;
		
		block.freieBahnAngefordert();		
		while (block.habe_freie_bahn) {
			try {
				Thread.sleep(1000);
			} catch (InterruptedException e) {
				System.out.println ("Bahnhof interrupt");
			}
		}

		try {
			Thread.sleep(2000);
		} catch (InterruptedException e) {
			System.out.println ("Bahnhof interrupt");
		}
		
		block.vorgeblockt();
		if (block.links == null) {
			z = new Zug (block, true, zl, 1500, 10);
		} else {
			z = new Zug (block, false, zl, 1500, 10);
		}
		try {
			Thread.sleep(30000);
		} catch (InterruptedException e) {
			System.out.println ("Bahnhof interrupt");
		}
		block.geblockt();
		
		new Thread(z).start();
		
		lock = false;
	}

	boolean lock;
	Block block;
	int zl;
}
