/*
 * (c) 2005 by Simon Gander <simongander@gmx.ch>
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

package guettingen;

class Signalhebel extends Hebel {
	public Signalhebel (int nr, String filename_schild, boolean fb_hebel, Hebelsperre sig_k, Signal sig) {
		super (nr, filename_schild);
		hebel_plus = sh_plus;
		hebel_minus = sh_minus;
		hat_fb_hebel = fb_hebel;
		sk = (Signalhebelsperre)sig_k;
		sig_anz = sig;
	}
	
	public void positionMinus () {
		if (wiederholsperre) return;
		if (freigabe == 0 && sig_anz != null) return;
		if (position == true) return;
		if (!sk.umlegenOk(position)) return;
		if (hat_fb_hebel) {
			if (fb_hebel_pos == (freigabe == 1)) return;
		}
		// Fahrbegriffhebel pruefen
		position = true;
		sk.umlegen(position);
		if (sig_anz != null) {
			wiederholsperre = true;
			if (freigabe == 1) sig_anz.Fahrt();
			if (freigabe == 2) sig_anz.Fahrt2();
			Hauptfenster.anz.repaintLampen();
		}
	}
	
	public void positionPlus () {
		if (position == false) return;
		if (festgehalten) return;
//		if (!sk.umlegenOk(position)) return;
		position = false;
		sk.umlegen(position);
		if (sig_anz != null) {
			sig_anz.Halt();
			Hauptfenster.anz.repaintLampen();
			sk.sperren();
		}
	}
	
	public boolean position() {
		if (freigabe != 1) return false;
		return position;
	}
	
	public void signalFreigeben (int begriff) {
		freigabe = begriff;
		sk.freigeben();
	}
	
	public boolean signalSperren () {
		if (position) return false;
		freigabe = 0;
		sk.sperren();
		wiederholsperre = false;
		return true;
	}
	
	public void signalFesthalten () {
		festgehalten = true;
	}
	
	public void signalLoslassen () {
		festgehalten = false;
	}
	
	int freigabe;	// Halt = 0, Fahrt 1 = 1, Fahrt 2 = 2
	Signalhebelsperre sk;
	Signal sig_anz;
	boolean festgehalten;
	boolean wiederholsperre;
	
	static final long serialVersionUID = 8039995483777801310L;
}
